import Vue from 'vue'
import VueRouter from 'vue-router'
import Home from "../views/Home.vue"
import Login from "../views/Login.vue"
import Product from "../views/Product.vue"
import BlogEdit from "../views/BlogEdit.vue"
import jwt_decode from "jwt-decode";
import store from "../store/index.js"

Vue.use(VueRouter)



const routes = [
  {
    path: "/",
    name: "Home",
    component: Home
  },
  {
    path: "/login",
    name: "Login",
    component: Login
  },
  {
    path: "/product",
    name: "Product",
    component: Product
  },
  {
    path: "/blogedit",
    name: "BlogEdit",
    component: BlogEdit
  },

]

const router = new VueRouter({
  mode:"history",
  routes
})
  
//只有在跳转页面时才会执行
router.beforeEach((to, from, next) => {
  
  //to 将要访问的路径
  //from 代表从哪个路径而来
  //next() 代表放行 next('xxx') 强制放行的xxx的路径
  if(to.path==='/login'){
      next();
  }else{
      const tokenStr = window.localStorage.getItem('token');

      console.log(tokenStr);        
      if(!tokenStr){
        alert("请你先登陆")
          return next('/login')
         }
         const token = jwt_decode(tokenStr);
         const currentTime = Date.now() / 1000;
         if (currentTime > token.exp) {
          store.commit("delToken");    //删除token
          console.log("已超时");        
          alert("登陆过期,请你重新登陆")    
          return next('/login')         
        }     
      

      next();
  }

})

export default router
