import Vue from 'vue'
import Vuex from 'vuex'
Vue.use(Vuex);

const store = new Vuex.Store({
    state: {
      //定义一个state存储token信息
        token: localStorage.getItem('token') ? localStorage.getItem('token') : ''
      },
      mutations: {
        //登录后通过setToken存入token token保存在state和localStorage中,放入请求头中
        setToken (state,token) {
          state.token =token;
          localStorage.setItem("token",token.token);     //存储token
        },
        //登出后通过delToken清除token
        delToken (state) {
          state.token = '';
          localStorage.removeItem("token");    //删除token
        }
    }    
});

export default store;

